-- GearSwitch v1.00 by d07.RiV (Iroared)
-- All rights reserved

GearSwitch = CreateFrame ("Frame")
local GS = GearSwitch

local dbkey = UnitName ("player") .. " - " .. GetRealmName ()

--------------------------------------------------------------------------

function GS:PreLogout ()
  if self.db[dbkey] then
    UseEquipmentSet (self.db[dbkey])
  end
end
function GS:OnInitialize ()
  local B_Logout = Logout
  local B_Quit = Quit

  Logout = function ()
    self:PreLogout ()
    B_Logout ()
  end
  Quit = function ()
    self:PreLogout ()
    B_Quit ()
  end
end

--------------------------------------------------------------------------

function GS:OnEvent (event, ...)
  if self[event] then
    self[event] (self, ...)
  end
end

function GS:ADDON_LOADED (addon)
  if addon == "GearSwitch" then
    GearSwitchDB = GearSwitchDB or {}
    self.db = GearSwitchDB

    GS:OnInitialize ()

    SlashCmdList["GearSwitch"] = function (cmd) self:OnCommand (cmd) end
    SLASH_GearSwitch1 = "/gearswitch"
  end
end

GS:SetScript ("OnEvent", GS.OnEvent)
GS:RegisterEvent ("ADDON_LOADED")

function GS:OnCommand (cmd)
  if cmd == "off" then
    self.db[dbkey] = nil
  elseif cmd and cmd ~= "" then
    self.db[dbkey] = cmd
  end
  DEFAULT_CHAT_FRAME:AddMessage ("Current equipment set at logout: " .. (self.db[dbkey] or "|cffff0000off|r"))
end
